from pairs import pairs
from shuffle_step import shuffle_step
from ceil_log2 import ceil_log2


def shuffle (probs, owners, attackers=None):
	v = probs[:]
	o = owners[:]
	quantity = len (v)
	steps = ceil_log2 (quantity)

	for step in range (1, steps+1):
		p = pairs (quantity, step)
		v, o = shuffle_step (v, o, p, attackers)
	return v, o


if __name__ == '__main__':
	from initial_probs import initial_probs

	quantity = 8
	v = initial_probs (quantity)
	owners = list (range (quantity))

	v, o = shuffle (v, owners)
	print ('# owners')
	print (owners)
	print ('# probabilities vector')
	for n in v: print (n)
