from butterfly import butterfly_probs, butterfly_owners


def shuffle_step (probs, owners, pair_list, attackers=None):
	v = probs [:]
	o = owners [:]
	for n, m in pair_list:
		# shuffle if neither n, m or is an attacker
		if (attackers==None) or not (attackers[n] or attackers[m]):
			v[n], v[m] = butterfly_probs (v[n], v[m])
			o[n], o[m] = butterfly_owners (o[n], o[m])
	return v, o


if __name__ == '__main__':
	from initial_probs import initial_probs
	from pairs import pairs

	n_voters = 8
	step = 1

	v = initial_probs (n_voters)
	owners = list (range (n_voters))

	p = pairs (n_voters, step, offset=0)
	v, owners = shuffle_step (v, owners, p)

	print ('# owners')
	print (owners)
	print ('# probabilities vector')
	for n in v: print (n)

